• HDU-3295-An interesting mobile game(BFS+DFS)


    Problem Description
    XQ,one of the three Sailormoon girls,is usually playing mobile games on the class.Her favorite mobile game is called “The Princess In The Wall”.Now she give you a problem about this game.
    Can you solve it?The following picture show this problem better.

    This game is played on a rectangular area.This area is divided into some equal square grid..There are N rows and M columns.For each grid,there may be a colored square block or nothing.
    Each grid has a number.
    “0” represents this grid have nothing.
    “1” represents this grid have a red square block.
    “2” represents this grid have a blue square block.
    “3” represents this grid have a green square block.
    “4” represents this grid have a yellow square block.

    1. Each step,when you choose a grid have a colored square block, A group of this block and some connected blocks that are the same color would be removed from the board. no matter how many square blocks are in this group.
    2. When a group of blocks is removed, the blocks above those removed ones fall down into the empty space. When an entire column of blocks is removed, all the columns to the right of that column shift to the left to fill the empty columns.

    Now give you the number of the row and column and the data of each grid.You should calculate how many steps can make the entire rectangular area have no colored square blocks at least.
     

    Input
    There are multiple test cases. Each case starts with two positive integer N, M,(N, M <= 6)the size of rectangular area. Then n lines follow, each contains m positive integers X.(0<= X <= 4)It means this grid have a colored square block or nothing.
     

    Output
    Please output the minimum steps.
     

    Sample Input
    5 6 0 0 0 3 4 4 0 1 1 3 3 3 2 2 1 2 3 3 1 1 1 1 3 3 2 2 1 4 4 4
     

    Sample Output
    4
    Hint
    0 0 0 3 4 4 0 0 0 4 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 3 3 3 0 0 3 3 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 2 1 2 3 3 0 0 3 3 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 3 3 2 2 2 3 3 0 2 2 2 4 4 0 2 2 0 0 0 0 0 0 0 0 0 0 2 2 1 4 4 4 2 2 4 4 4 0 2 2 4 4 4 0 2 2 2 0 0 0 0 0 0 0 0 0
     

    Author
    B.A.C
     

    Source


    思路:由于方块会越消越少,所以不是必需判重。注意消去之后。上面的会掉下来,假设某一列全为是空的。右边的会往左移。左移的时候注意连续两列为空的情况,尽管数据弱。之前没考虑也AC了。


    #include <stdio.h>
    
    struct{
    int d[6][6],step;
    }que[1000000],t;
    
    int n,m,temp[6][6],nxt[4][2]={{0,1},{1,0},{0,-1},{-1,0}};
    bool vis[6][6];
    
    void dfs(int x,int y,int num)
    {
        for(int i=0;i<4;i++)
        {
            x+=nxt[i][0];
            y+=nxt[i][1];
    
            if(x>=0 && x<n && y>=0 && y<m && !vis[x][y] && temp[x][y]==num)
            {
                vis[x][y]=1;
    
                t.d[x][y]=0;
    
                dfs(x,y,num);
            }
    
            x-=nxt[i][0];
            y-=nxt[i][1];
        }
    }
    
    int main()
    {
        int i,j,k,p,q,top,bottom;
        bool flag;
    
        while(~scanf("%d%d",&n,&m))
        {
            for(i=0;i<n;i++) for(j=0;j<m;j++) scanf("%d",&que[0].d[i][j]);
    
            top=0;
            bottom=1;
    
            que[0].step=0;
    
            while(top<bottom)
            {
                t=que[top];
    
                flag=1;
    
                for(i=0;i<n && flag;i++) for(j=0;j<m && flag;j++) if(t.d[i][j]) flag=0;
    
                if(flag)
                {
                    printf("%d
    ",t.step);
    
                    break;
                }
    
                t.step++;
    
                for(i=0;i<n;i++) for(j=0;j<m;j++) temp[i][j]=t.d[i][j],vis[i][j]=0;
    
                for(i=0;i<n;i++) for(j=0;j<m;j++)
                {
                    if(temp[i][j] && !vis[i][j])
                    {
                        vis[i][j]=1;
    
                        t.d[i][j]=0;
    
                        dfs(i,j,temp[i][j]);
    
                        for(p=n-1;p>=0;p--)//向下移动
                        {
                            for(q=0;q<m;q++)
                            {
                                if(!t.d[p][q])
                                {
                                    for(k=p-1;k>=0;k--)
                                    {
                                        if(t.d[k][q])
                                        {
                                            t.d[p][q]=t.d[k][q];
                                            t.d[k][q]=0;
    
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                        
                        int tt=m-1;
                        while(tt--)//向左移动,注意连续两列都为空的情况。
                        {
                            for(q=0;q<m-1;q++)
                            {
                                for(p=0;p<n;p++) if(t.d[p][q]) break;
    
                                if(p<n) continue;
    
                                for(p=0;p<n;p++)
                                {
                                    t.d[p][q]=t.d[p][q+1];
                                    t.d[p][q+1]=0;
                                }
                            }
                        }
    
                        que[bottom++]=t;
    
                        for(p=0;p<n;p++) for(q=0;q<m;q++) t.d[p][q]=temp[p][q];
                    }
                }
    
                top++;
            }
        }
    }

  • 相关阅读:
    IOS异常日志记录与展现功能
    关于仿网易新闻中详细页图文混排功能的实现
    IOS开发基础知识--碎片22
    利用UIScrollView实现几个页面的切换
    IOS开发基础知识--碎片21
    IOS开发基础知识--碎片20
    左右侧滑菜单功能的实现
    空页面的背景提示原理
    等待时动画效果的实现
    解析虚拟VMware三种网络模式的根本区别
  • 原文地址:https://www.cnblogs.com/yjbjingcha/p/6907917.html
Copyright © 2020-2023  润新知